﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
using System.Threading;
//using System.IO;

namespace MPSMinCon
{
    class Solution
    {      
        Problemi problemiObj;
        Random rand = new Random(Guid.NewGuid().GetHashCode());
        //int[,] zgjidhjaPerkoheshme;
        public int[,] zgjidhjaMeeMire, rendAct;
        int[] vAct, varguActMM;
        int NrAct, NrProj;
        public int deltaF = int.MaxValue;
        internal ArrayList varConflict = new ArrayList();
        internal int[] Timeline_i;
        
        public Solution(string str)
        {
            problemiObj = new Problemi(new System.IO.StreamReader(str));           
            NrAct = problemiObj.noActivitiesTotal;
            //Rezultati.NAct = NrAct;
            NrProj = problemiObj.noProjects;
            //Rezultati.NProj = NrProj;
            Rezultati.OpExecTime = (problemiObj.aModRes.GetLength(0) - NrProj * 2) / (NrAct - NrProj * 2);
            Rezultati.OpExecTime *= 1000;
            Rezultati.projFill = new int[NrProj];
            Rezultati.Starti = Rezultati.GjejStartin(problemiObj);
            Rezultati.modesTabuListLen = NrAct * 3 / 10;
            Rezultati.seqTabuListLen = NrAct * 1 / 5;          
            GjeneroInit();
            Rezultati.stDt = DateTime.Now;
            Rezultati.initDt = Rezultati.stDt.AddMilliseconds(60000);
            if (Rezultati.nrSec > 600) Rezultati.altDt = Rezultati.stDt.AddMilliseconds((Rezultati.nrSec/2)*1000);
        }

        private void GjeneroInit()
        {
            rendAct = new int[NrAct, 3];
            vAct = new int[NrAct];
            zgjidhjaMeeMire = new int[NrAct, 3];
            varguActMM = new int[NrAct];
            //zgjidhjaPerkoheshme = new int[NrAct, 4];
            Timeline_i = new int[NrProj];
            int l = 0, zh = 0;
            //for (int i = 0; i < NrAct; i++)
            //{
            //    rendAct[i, 0] = -1;...          
            //}
            int kohaStartit = 0;
            for (int i = 0; i < NrProj; i++)
            {
                int z = problemiObj.projectInfoPr[i, 1], sh = zh;
                int starttime = problemiObj.projectInfoPr[i, 2];
                while (z > 0)
                {
                    if (problemiObj.precedenceRelationsPrPre[sh].Length > 3)
                    {
                        int k = 3;
                        bool UGjet = false;
                        while (!UGjet && k < problemiObj.precedenceRelationsPrPre[sh].Length)
                        {
                            if (!VarguPermban(problemiObj.precedenceRelationsPrPre[sh][k])) UGjet = true;
                            k++;
                        }

                        if (!UGjet)
                        {
                            int acmode = 0, acduration = 0;
                            vAct[l] = problemiObj.precedenceRelationsPrPre[sh][2];
                            //vAct[l] = rendAct[l, 0];
                            KtheModin(vAct[l], ref acmode, ref acduration);//
                            rendAct[l, 0] = acmode;
                            rendAct[l, 1] = acduration;
                            kohaStartit += kohaStartit + acduration;
                            rendAct[l, 2] = kohaStartit;
                            l++;
                            sh++;
                        }
                    }
                    else
                    {
                        if (problemiObj.precedenceRelationsPrPre[sh].Length == 3)
                        {
                            int acmode = 0, acduration = 0;
                            vAct[l] = problemiObj.precedenceRelationsPrPre[sh][2];
                            //vAct[l] = rendAct[l, 0];
                            KtheModin(vAct[l], ref acmode, ref acduration);
                            rendAct[l, 0] = acmode;
                            rendAct[l, 1] = acduration;
                            rendAct[l, 2] = starttime;
                            l++;
                            sh++;
                        }
                    }
                    z--;
                    if ((z == 0) && (sh < problemiObj.projectInfoPr[i, 1]))
                    {
                        sh = zh;
                        z = problemiObj.projectInfoPr[i, 1];
                        l = 0;
                    }
                }
                zh += problemiObj.projectInfoPr[i, 1]; //;
            }
            int jk = 0;
            for (int i = 0; i < Rezultati.AThjLen1 - 1; i++)
            {
                if (Rezultati.actThjeshtimi[i, 0] != Rezultati.actThjeshtimi[i + 1, 0]) { Timeline_i[jk] = Rezultati.actThjeshtimi[i, 2]; jk++; }
            }
            Timeline_i[jk] = Rezultati.actThjeshtimi[Rezultati.AThjLen1 - 1, 2];
        }

        //private int GjejStartTime(int a)
        //{
        //    int i = 0, maxTime = -1;
        //    while (problemiObj.precedenceRelationsPrPre[i][2] != a)
        //        i++;

        //    int k = 3;
        //    while (k < problemiObj.precedenceRelationsPrPre[i].Length)
        //    {
        //        if ((rendAct[problemiObj.precedenceRelationsPrPre[i][k], 1] + rendAct[problemiObj.precedenceRelationsPrPre[i][k], 2]) > maxTime)
        //            maxTime = rendAct[problemiObj.precedenceRelationsPrPre[i][k], 1] + rendAct[problemiObj.precedenceRelationsPrPre[i][k], 2];
        //        k++;
        //    }
        //    return maxTime;
        //}

        private void KtheModin(int act, ref int amod, ref int adur)
        {
            int i = 0;
            adur = int.MaxValue;
            int nrModeve = problemiObj.precedenceRelationsPrSuc[act][1];          
            int[,] vargAct = problemiObj.DicT[act];        

            while (i < nrModeve)//
            {
                //if (problemiObj.aModRes[i, 2] < adur) { amod = problemiObj.aModRes[i, 1]; adur = problemiObj.aModRes[i, 2]; }
                if (vargAct[i, 1] < adur) { amod = vargAct[i, 0]; adur = vargAct[i, 1]; }
                i++;
            }
        }

        private bool VarguPermban(int vl)
        {
            for (int i = 0; i < NrAct; i++)
                if ( vAct[i] == vl) return true;

            return false;
        }

       
        internal int Funksioni_ObjFinal()//
        {
            int TPD = 0, TMS = 0;

            for (int i = 0; i < NrProj; i++)
            {
                TPD += rendAct[Rezultati.fillFundProjekteve[i, 1], 2] - rendAct[Rezultati.fillFundProjekteve[i, 0], 2] - problemiObj.projectInfoPr[i, 5];
                if (rendAct[Rezultati.fillFundProjekteve[i, 1], 2] > TMS) TMS = rendAct[Rezultati.fillFundProjekteve[i, 1], 2];// rendAct[indeksatFun[i], 3];
            }
            return (TPD * 100000 + TMS);
        }

     
        internal void KtheZgjidhjeZMMtoRACT()
        {
            Buffer.BlockCopy(zgjidhjaMeeMire, 0, rendAct, 0, zgjidhjaMeeMire.Length * sizeof(int));
        }

        internal void KtheRenditjeMMtoRend()
        {
            Buffer.BlockCopy(varguActMM, 0, vAct, 0, varguActMM.Length * sizeof(int));
        }

        internal void KtheRenditjeRendtoMM()
        {
            Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
        }
       
        internal void KtheZgjidhjeReztoRACT()
        {            
            Buffer.BlockCopy(Rezultati.rezultati, 0, rendAct, 0, Rezultati.rezultati.Length * sizeof(int));
        }

        internal void KtheRenditjetoRACT()
        {
            Buffer.BlockCopy(Rezultati.renditjaMM, 0, vAct, 0, Rezultati.renditjaMM.Length * sizeof(int));
        }

        internal void KtheRenditjeMM()
        {
            Buffer.BlockCopy(varguActMM, 0, Rezultati.renditjaMM, 0, varguActMM.Length * sizeof(int));
        }
              
        internal void KtheZgjidhjeZMMtoRez()
        {
            Buffer.BlockCopy(zgjidhjaMeeMire, 0, Rezultati.rezultati, 0, zgjidhjaMeeMire.Length * sizeof(int));
        }
            
        private void KtheVarNeKonfliktRenLocl(ArrayList act)
        {
            int acTual, acTMode = 0;//, nrProj;
            int[] resglobal = new int[problemiObj.globalResources.Length];
            ArrayList vrg = new ArrayList();
            int reslocal0 = problemiObj.localResources.GetLength(0);
            int reslocal1 = problemiObj.localResources.GetLength(1);
            int[,] reslocal = new int[reslocal0, reslocal1];
            for (int i = 0; i < act.Count; i++)
            {
                int indk = (int)act[i]; //ActIndeks(acTual);
                acTual = vAct[indk];// rendAct[indk, 0];
                acTMode = rendAct[vAct[indk], 0];
                int j = 0;
                int[,] vargAct = problemiObj.DicT[acTual];
                int nrModeve = problemiObj.precedenceRelationsPrSuc[acTual][1];
                while (j < nrModeve)//
                {
                    if (vargAct[j, 0] == acTMode)//problemiObj.aModRes[j, 1] == acTMode)//vrg1[0, 1])
                    {
                        int nrLocRes = problemiObj.projectInfoPr[Rezultati.actThjeshtimi[acTual, 0], 6];//   problemiObj.aModRes[j, Rezultati.AModLen2 - 1], 6];
                        for (int k = 0; k < nrLocRes; k++)// reslocal.GetLength(1); k++)
                        {
                            reslocal[Rezultati.actThjeshtimi[acTual, 0], k] += vargAct[j, k + 2];
                        }
                    }
                    j++;
                }
            }

            for (int l = 0; l < reslocal0; l++)
            {
                int p = problemiObj.projectInfoPr[l, 6];
                for (int q = 0; q < p; q++)
                {
                    if (problemiObj.localResources[l, q] < 0)
                    {
                        resglobal[q] += reslocal[l, q];//problemiObj.aModRes[jl, k + 3];
                        if (resglobal[q] > problemiObj.globalResources[q])
                        {
                            foreach (var a1 in act)
                            {
                                if (!varConflict.Contains(a1)) varConflict.Add(a1); 
                            }
                            break;
                        }
                    }
                    else if (reslocal[l, q] > problemiObj.localResources[l, q])
                    {
                        foreach (var a1 in act)
                        {
                            if (!varConflict.Contains(a1)) varConflict.Add(a1);
                        }
                        break;
                    }
                }

            }
        }

           
        internal void GenerateInitSolution()
        {
            SNonRenRes();             
            Scheduler(0);
            KtheRenditjeRendtoMM();
        }


        private void SNonRenRes()
        {
            bool UgjetNjeZgjidhje = false;
            int[,] rActTemp = new int[NrAct, 3];
            Buffer.BlockCopy(rendAct, 0, rActTemp, 0, rendAct.Length * sizeof(int));
            int z = -1, nrTries=0;//,u=0;// tmpO = int.MaxValue;
            ArrayList allProj = new ArrayList();
            for (int i = 0; i < NrProj; i++)
            {
                allProj.Add(i);
            }
            varConflict.Clear();
            int y = NonRenLocalModCh(allProj);// 
            int dimProj = -2, n = -1, poz = -1;
            if (varConflict.Count > 0)
            {
                z = rand.Next(0, varConflict.Count);
                z = (int)(varConflict[z]);
                dimProj = problemiObj.projectInfoPr[z, 1];
                n = Rezultati.fillFundProjekteve[z, 0];// 
                poz = rand.Next(n, dimProj + n);
            }
            else UgjetNjeZgjidhje = true;

            while (!UgjetNjeZgjidhje)
            {
                for (int i = poz; i < dimProj + n; i++)
                {
                    SposNRRSec(i, z);//
                    if (varConflict.Count == 0) break;
                }
                if (varConflict.Count == 0) UgjetNjeZgjidhje = true;
                else
                {                    
                    for (int i = n; i < poz; i++)
                    {
                        SposNRRSec(i, z);
                        if (varConflict.Count == 0) break;//
                    }
                    if (varConflict.Count == 0) UgjetNjeZgjidhje = true;
                }
                varConflict.Clear();
                y = NonRenLocalModCh(allProj);// 
                if (varConflict.Count > 0)
                {
                    UgjetNjeZgjidhje = false;
                    if (nrTries > NrProj) { Buffer.BlockCopy(rActTemp, 0, rendAct, 0, rActTemp.Length * sizeof(int)); nrTries = 0; }
                    z = rand.Next(0, varConflict.Count);
                    z = (int)(varConflict[z]);
                    dimProj = problemiObj.projectInfoPr[z, 1];
                    n = Rezultati.fillFundProjekteve[z, 0];// 
                    poz = rand.Next(n, dimProj + n);
                    nrTries++;
                }
            }
        }

        private void SposNRRSec(int z, int prj1)
        {
            int modZ, durZ;
            int indk = z;// ActIndeks(z);// actIndekset[z];
            ArrayList prList = new ArrayList();
            prList.Add(prj1);
            modZ = rendAct[indk, 0];
            durZ = rendAct[indk, 1];
            //z = rendAct[indk, 0];
            int l, peshaNonRes = int.MaxValue, x;//varConflict.Count;
            int[,] rActTemp = new int[NrAct, 3];
            bool KaNdryshim = false;
            int nrModeve = problemiObj.precedenceRelationsPrSuc[z][1];
            if (nrModeve > 1)
            {
                l = 0;// KtheIndeksBS(z);//rendAct[indk, 0]);
                int[,] vargAct = problemiObj.DicT[z];

                while (l < nrModeve)
                {
                    rendAct[indk, 0] = vargAct[l, 0];// modZ1;
                    rendAct[indk, 1] = vargAct[l, 1];//durModZ1;
                    varConflict.Clear();
                    x = NonRenLocalModCh(prList); //
                    if (x <= peshaNonRes)//Rezultati.peshaNRes)// 
                    {
                        peshaNonRes = x;// varConflict.Count;
                        Buffer.BlockCopy(rendAct, 0, rActTemp, 0, rendAct.Length * sizeof(int));
                        KaNdryshim = true;
                    }

                    l++;
                }
            }

            if (KaNdryshim)
            {
                Buffer.BlockCopy(rActTemp, 0, rendAct, 0, rActTemp.Length * sizeof(int)); //((varConflict.Count != 0) &&                   
            }
            else
            {
                rendAct[indk, 0] = modZ;
                rendAct[indk, 1] = durZ;
            }
        }

        private int NonRenLocalModCh(ArrayList aNeTst) 
        {
            int[,] nonreslocal = new int[problemiObj.localResources.GetLength(0), problemiObj.localResources.GetLength(1)];//
            int nonresLength0 = nonreslocal.GetLength(0);
            int nonresLength1 = nonreslocal.GetLength(1);
            int shuma = 0;
            int dimProj = Rezultati.AModLen2 - 1;
            foreach (var prj in aNeTst)
            {
                int proj = (int)prj;
                int nrActTot = problemiObj.projectInfoPr[proj, 1];
                int indPrSt;
                if (NrProj > 1)
                    indPrSt = KtheIndeksBSPr(proj);
                else indPrSt = 0;
                int hFi = Rezultati.fillFundProjekteve[proj, 0];
                int hFu = Rezultati.fillFundProjekteve[proj, 1];
                int nrLocR = problemiObj.projectInfoPr[proj, 7];//
                int startiNon = nonresLength1 - nrLocR;
                for (int h = hFi; h <= hFu; h++)
                {
                    indPrSt = 0;// 
                    Rezultati.vDct[0] = h;// rendAct[h, 0];
                    Rezultati.vDct[1] = rendAct[h, 0];// actModResPr[i, 1];
                    long hc = (Rezultati.vDct.GetHashCode() + h * 1000 + rendAct[h, 0]).GetHashCode();
                    int[] vargAct = problemiObj.DicTaModes[hc];//  DicT[rendAct[h, 0]];
                    for (int k = startiNon; k < nonresLength1; k++)
                    {
                        nonreslocal[proj, k] += vargAct[k + 1];
                    }
                }
                for (int i = startiNon; i < nonresLength1; i++)
                {
                    if (nonreslocal[proj, i] > problemiObj.localResources[proj, i])
                    {
                        shuma += nonreslocal[proj, i];
                        if (!varConflict.Contains(proj)) varConflict.Add(proj);
                    }
                }
            }
            return shuma; 
        }


        internal void INVS(int poz, int k)//kot
        {
            if (NrAct - poz < k) k = NrAct - poz;         
            int pz = poz, kj = poz + k;
            if (kj >= NrAct) kj = NrAct - 1;
            while ((pz != kj) && (pz < kj))
            {               
                int o3 = vAct[pz];// rendAct[pz, 0];
                vAct[pz] = vAct[kj];
                vAct[kj] = o3;

                pz++;
                kj--;
            }

            //{
            kj = poz + k;
            if (kj >= NrAct) kj = NrAct - 1;
            for (int j = poz; j <= kj - 1; j++)
            {
                for (int l = j + 1; l <= kj; l++)
                {
                    if (EshteParaardhesNeSeq(vAct[j], vAct[l])) //rendAct[j, 0], rendAct[l, 0]))
                    {
                        int a0 = vAct[j];// rendAct[j, 0];                       
                        vAct[j] = vAct[l];
                        int a = j, b = l;
                        while (a < b)
                        {
                            int p0 = vAct[a + 1];// 
                            vAct[a + 1] = a0;// 
                            a0 = p0;// 
                            a++;

                        }
                        if (j > 0) j = j - 1;
                    }
                }
            }
            Scheduler(poz);
        }

        private bool EshteParaardhesNeSeq(int po, int k)
        {
            if (Rezultati.actThjeshtimi[po, 0] == Rezultati.actThjeshtimi[k, 0])
            {
                for (int j = 3; j < problemiObj.precedenceRelationsPrPre[po].Length; j++)
                {
                    if (problemiObj.precedenceRelationsPrPre[po][j] == k) return true;
                }
            }
            return false;
        }

        private bool EshtePasardhesNeSeq(int po, int k)
        {
            if (Rezultati.actThjeshtimi[po, 0] == Rezultati.actThjeshtimi[k, 0])
            {
                for (int j = 3; j < problemiObj.precedenceRelationsPrSuc[po].Length; j++)
                {
                    if (problemiObj.precedenceRelationsPrSuc[po][j] == k) return true;
                }
            }
            return false;
        }

        internal void CloneSeq(int act)
        {
            int rnd = rand.Next(5, 16);
            if (rnd + act >= NrAct) rnd = NrAct - act;
            int[,] rAct = new int[NrAct, 3];
            ArrayList acNeTest = new ArrayList();
            Buffer.BlockCopy(rendAct, 0, rAct, 0, rendAct.Length * sizeof(int));
            for (int i = act; i <= rnd; i++)
            {               
                rendAct[vAct[i], 0] = Rezultati.rezultatiPerfundimtar[vAct[i], 0];
                rendAct[vAct[i], 1] = Rezultati.rezultatiPerfundimtar[vAct[i], 1];
                rendAct[vAct[i], 2] = Rezultati.rezultatiPerfundimtar[vAct[i], 2];

                int prj = Rezultati.actThjeshtimi[vAct[i], 0];// == pr1)
                if (!acNeTest.Contains(prj)) acNeTest.Add(prj);
            }

            varConflict.Clear();
            NonRenLocalModCh(acNeTest);
            if (varConflict.Count == 0)
            {
                Scheduler(act);
            }
            else Buffer.BlockCopy(rAct, 0, rendAct, 0, rAct.Length * sizeof(int));
        }
       
        internal void CloneProj(int prj)
        {
            int j, indrreg;
            j = ActIndk(Rezultati.fillFundProjekteve[prj, 0]); //
            indrreg = j;
            int act = Rezultati.fillFundProjekteve[prj, 0];// vAct[j];
            int dimProj = problemiObj.projectInfoPr[prj, 1];
            int k = 0;
            while (k < dimProj) 
            {
                rendAct[act, 0] = Rezultati.rezultatiPerfundimtar[act, 0];
                rendAct[act, 1] = Rezultati.rezultatiPerfundimtar[act, 1];
                rendAct[act, 2] = Rezultati.rezultatiPerfundimtar[act, 2];
                k++;
                act++;
            }
            Scheduler(indrreg);
        }

        internal void CloneProjPart(int prj)
        {
            int j, l, indrreg;//,             
            int dimProj = problemiObj.projectInfoPr[prj, 1];
            int dimParcial2 = dimProj * (3 / 5);
            int dimParcial1 = dimProj * (2 / 5);//3 / 10);
            l = rand.Next(dimParcial1, dimParcial2);
            int pozitaIndeks = rand.Next(0, dimProj - l);
            int n = Rezultati.fillFundProjekteve[prj, 0];// KtheIndeksRendAct(Rezultati.fillFundProjekteve[prj, 0]);//
            j = ActIndk(n + pozitaIndeks);//rendAct[n + pozitaIndeks, 0]); //            
            indrreg = j;
            ArrayList acNeTest = new ArrayList();
            int[,] rAct = new int[NrAct, 3];
            Buffer.BlockCopy(rendAct, 0, rAct, 0, rendAct.Length * sizeof(int));
            int act = vAct[j]; 
            int k = 0;
            while (k < l)
            {
                rendAct[k + act, 0] = Rezultati.rezultatiPerfundimtar[k + act, 0];
                rendAct[k + act, 1] = Rezultati.rezultatiPerfundimtar[k + act, 1];
                rendAct[k + act, 2] = Rezultati.rezultatiPerfundimtar[k + act, 2];

                k++;
            }
            acNeTest.Add(prj);
            varConflict.Clear();
            NonRenLocalModCh(acNeTest);
            if (varConflict.Count == 0)
            {
                Scheduler(indrreg);
            }
            else Buffer.BlockCopy(rAct, 0, rendAct, 0, rAct.Length * sizeof(int));            
        }
        
        internal void _MinConSJL()//, bool opInter)
        {
            int dlf = int.MaxValue, z;
            bool KaNdr = true;           
            DateTime dt = DateTime.Now;
            DateTime dt1 = dt.AddMilliseconds(1000);
            DateTime dt2 = dt.AddMilliseconds(3000);
            while (((KaNdr) || (DateTime.Now < dt1)) && (DateTime.Now < dt2))//(DateTime.Now < dt2)// 
            {
                KaNdr = false;
                z = rand.Next(0, NrAct);//fi, fu);//
                int nrParaardhes =  problemiObj.precedenceRelationsPrPre[vAct[z]].Length - 3;// problemiObj.precedenceRelationsPrSuc[vAct[z]].Length;// 
                while ((nrParaardhes == 0) || (Rezultati.IsTD(vAct[z], Rezultati.seqTabuListLen, Rezultati.dcTN2)))// (Rezultati.IsT(vAct[z])))//
                {
                    z = rand.Next(0, NrAct);//fi, fu);//0, NrAct);
                    nrParaardhes = problemiObj.precedenceRelationsPrPre[vAct[z]].Length - 3;
                }
                if (MinConSJL(z, ref dlf)) //
                {
                        if (dlf <= deltaF)
                        {
                            Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                            Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));//
                            //if (dlf < deltaF)
                            //{
                                KaNdr = true;
                                deltaF = dlf;
                            //}
                        }
                   
                }
            }
        }


        internal void _ComF(bool ND)//
        {
            if (NrProj > 1)
            {
                int tmpObj = int.MaxValue;//, 
                int nrproj = rand.Next(0, NrProj);//,
                    if (ND)
                        CloneProjPart(nrproj);// 
                    else
                        CloneProj(nrproj);
                    tmpObj = Funksioni_ObjFinal();//
                    if (tmpObj < deltaF)
                    {
                        deltaF = tmpObj;
                        Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                        Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                    }
                        int z22 = rand.Next(0, NrProj);
                        while (z22 == nrproj)
                            z22 = rand.Next(0, NrProj);
                        ComF(z22);
                        tmpObj = Funksioni_ObjFinal();
                        if (tmpObj < deltaF)
                        {
                            deltaF = tmpObj;
                            Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                            Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                        }
            }
        }

       
        internal void _ComE(bool ND)//
        {          
            int nrproj = rand.Next(0, NrProj);//,  
            int tmpObj;//              

            if (ND)
            {
                if (NrProj > 1)
                {
                    CloneProj(nrproj);
                    tmpObj = Funksioni_ObjFinal();
                    if (tmpObj < deltaF)
                    {
                        deltaF = tmpObj;
                        Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                        Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                    }
                }
            }
            else
            {
                CloneProjPart(nrproj);
                tmpObj = Funksioni_ObjFinal();
                if (tmpObj < deltaF)
                {
                    deltaF = tmpObj;
                    Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                    Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                }
            }
            if (NrProj > 1)
            {
                int z22 = rand.Next(0, NrProj);
                while (z22 == nrproj) //Rezultati.IsP(z22))//
                    z22 = rand.Next(0, NrProj);
                ComE(z22);//
                tmpObj = Funksioni_ObjFinal();//Funksioni_Obj(); //Obj_Funksioni(true);          
                if (tmpObj < deltaF)
                {
                    deltaF = tmpObj;
                    Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                    Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                }
            }
        }


        internal void _MinConOMC(ref bool KB)//
        {
            int z;//           
            bool KaPer = true;
            int fi = 0, fu = NrAct;//
            int dlf = int.MaxValue;          
            while (KaPer)//
            {
                KaPer = false;
                z = rand.Next(fi, fu);
                while (Rezultati.IsTD(vAct[z], Rezultati.modesTabuListLen, Rezultati.dcTN1))// 
                {
                    z = rand.Next(fi, fu);
                }
                if (MinConOMC(z, ref dlf))
                {
                    if (dlf < deltaF)
                    {
                        deltaF = dlf;                       
                        Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                        Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                        KaPer = true;
                        KB = true;
                    }                          
                }              
            }
        }


        internal void _InitTMC(ref bool op, int y)//, ref int nrp)
        {
            int z;
            //int nrproj = rand.Next(0, NrProj);
            int fi = 0, fu = NrAct, dm = NrAct / 4;
            int dlf = int.MaxValue; //Funksioni_ObjFinal();// 
       
            switch (y)
            {
                case 1: fi = 0; fu = dm; break;
                case 2: fi = dm - 1; fu = 2 * dm; break;
                case 3: fi = 2 * dm - 1; fu = 3 * dm; break;
                case 4: fi = 3 * dm - 1; fu = 4 * dm; break;
            }
            DateTime dt = DateTime.Now;
            DateTime dt1 = dt.AddMilliseconds(1000);
            while (DateTime.Now < dt1)
            {
                z = rand.Next(fi, fu);//fi, fu);//0, NrAct);
                while (Rezultati.IsT(vAct[z]))
                {
                    z = rand.Next(fi, fu);
                }
                if (MinConTMC(z, ref dlf))
                {
                    if (dlf < deltaF)
                    {
                        deltaF = dlf;
                        Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                        Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                        op = true;
                    }                  
                }          
            }
        }


        internal void _PCOM()
        {
            if (NrProj > 1)
            {
                int nrproj = rand.Next(0, NrProj);
                PCom(nrproj);

                int tmpObj = Funksioni_ObjFinal();
                if (tmpObj < deltaF)
                {
                    deltaF = tmpObj;
                    Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                    Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                }
            }
        }



        internal void _MinConTMC()//int y)
        {
            int z;
            int fi = 0, fu = NrAct;//, 
            int dlf = int.MaxValue;          
            DateTime dt = DateTime.Now;
            DateTime dt1 = dt.AddMilliseconds(Rezultati.OpExecTime);//3 
            while (DateTime.Now < dt1)
            {
                z = rand.Next(fi, fu);//
                while (Rezultati.IsT(vAct[z]))//
                {
                    z = rand.Next(fi, fu);//
                }
                if (MinConTMC(z, ref dlf))
                {
                    if (dlf <= deltaF)
                    {
                        deltaF = dlf;
                        Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                        Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                    }
                }              
            }
        }


        internal void _INVS()
        {
            if (NrProj > 1)
            {
                int z;
                int fi = 0, fu = NrAct;//
                bool KaNdr = true;//
                DateTime dt = DateTime.Now;
                DateTime dt1 = dt.AddMilliseconds(1000);
                DateTime dt2 = dt.AddMilliseconds(3000);
                int nrInv;
                while (((KaNdr) || (DateTime.Now < dt1)) && (DateTime.Now < dt2))//
                {
                    KaNdr = false;
                    z = rand.Next(fi, fu);//0, NrAct);//
                    int nrParaardhes = problemiObj.precedenceRelationsPrPre[vAct[z]].Length - 3;
                    while ((nrParaardhes == 0) || (Rezultati.IsTD(vAct[z], Rezultati.seqTabuListLen, Rezultati.dcTN2)))//
                    {
                        z = rand.Next(fi, fu);//
                        nrParaardhes = problemiObj.precedenceRelationsPrPre[vAct[z]].Length - 3;
                    }
                    int pozFill = z - 1;
                    int act = vAct[z];
                    nrInv = 0;
                    while (!EshteParaardhesNeSeq(act, vAct[pozFill]))//
                    {
                        pozFill--;
                        nrInv++;
                        if (pozFill < 0) { pozFill = 0; break; }
                    }
                    INVS(z - nrInv, nrInv);//
                    int tmpObj = Funksioni_ObjFinal();// 
                    if (tmpObj < deltaF)
                    {
                        KaNdr = true;
                        deltaF = tmpObj;
                        Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                        Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                    }

                }
            }                
        }
                
        internal void InicializoRezultatin()
        {
            Rezultati.rezultati = new int[NrAct, 3];
            Rezultati.renditjaMM = new int[NrAct];
            Rezultati.rezultatiPerfundimtar = new int[NrAct, 3];
        }

        private bool Perseriten(ArrayList aPers, int a1, int a2)
        {
            for (int i = 0; i < aPers.Count - 1; i++)
            {
                int b1 = (int)aPers[i];
                int b2 = (int)aPers[i + 1];
                if (((b1 == a1) && (b2 == a2)) || ((b1 == a2) && (b2 == a1))) { return true; }
            }
            return false;
        }

       
        internal bool MinConTMC(int starti, ref int dtf)//, int iter1) 
        {
            ArrayList al = new ArrayList();
            ArrayList actPerseritura = new ArrayList();           
            int tmpO = dtf;
            int[,] rAct = new int[NrAct, 3];
            int[,] rActTemp = new int[NrAct, 3];
            Buffer.BlockCopy(rendAct, 0, rAct, 0, rendAct.Length * sizeof(int));           
            int modZ02;
            bool KaNderrim = false;       
            int varSetSize; //=  al.Count - 1;
            if (NrAct - starti >= 11) varSetSize = 11;
            else varSetSize = NrAct - starti;
            for (int yt = starti; yt < starti + varSetSize; yt++)
            {
                if (rendAct[vAct[yt], 1] > 0) al.Add(yt);
            }
            //tw = (tw / 2) + 1;
            int indeksi1;// = l, 
            int indeksi2;// = l;
            //int dimTabu = (NrAct * 6) / 10;
            //tw = (tw / 2) + 1;
            bool KaN = true;
                while ((KaN) && (al.Count > 1))//(w < tw)//
                {
                    KaN = false;
                    int act1, act2;//
                    indeksi1 = rand.Next(0, al.Count);
                    indeksi1 = (int)(al[indeksi1]);
                    act1 = vAct[indeksi1];// 
                    indeksi2 = rand.Next(0, al.Count);
                    indeksi2 = (int)(al[indeksi2]);
                    act2 = vAct[indeksi2];
                    if (!Perseriten(actPerseritura, indeksi1, indeksi2))
                    {
                        actPerseritura.Add(indeksi1);
                        actPerseritura.Add(indeksi2);
                        ArrayList acNeTest = new ArrayList();
                        int prj1 = Rezultati.actThjeshtimi[act1, 0];
                        acNeTest.Add(prj1);
                        int prj2 = Rezultati.actThjeshtimi[act2, 0];
                        if (!acNeTest.Contains(prj2)) acNeTest.Add(prj2);

                        int l;

                        int nrModeve1 = problemiObj.precedenceRelationsPrSuc[act1][1];
                        int nrModeve2 = problemiObj.precedenceRelationsPrSuc[act2][1];
                        l = 0;
                        int[,] vargAct1 = problemiObj.DicT[act1];
                        int[,] vargAct2 = problemiObj.DicT[act2];
                        modZ02 = rendAct[act1, 0];
                        int durModZ02 = rendAct[act1, 1];
                        int startZ02 = rendAct[act1, 2];

                        int modZ03 = rendAct[act2, 0];
                        int durModZ03 = rendAct[act2, 1];
                        int startZ03 = rendAct[act2, 2];

                        while (l < nrModeve1)//((l < Rezultati.AModLen1) && (problemiObj.aModRes[l, 0] == act1))
                        {
                            int modZ1 = vargAct1[l, 0];//problemiObj.aModRes[l, 1];                      
                            rendAct[act1, 0] = modZ1;
                            rendAct[act1, 1] = vargAct1[l, 1];//durModZ1;

                            int l2n = 0;

                            while (l2n < nrModeve2)//((l2n < Rezultati.AModLen1) && (problemiObj.aModRes[l2n, 0] == act2))
                            {
                                int modZ2 = vargAct2[l2n, 0];//problemiObj.aModRes[l2n, 1];
                                int durModZ2 = vargAct2[l2n, 1];//problemiObj.aModRes[l2n, 2];
                                if ((modZ1 != modZ02) || (modZ03 != modZ2))
                                {
                                    rendAct[act2, 0] = modZ2;
                                    rendAct[act2, 1] = durModZ2;
                                    varConflict.Clear();
                                    NonRenLocalModCh(acNeTest); //KtheVarNeKonfliktNonRenLocal(acNeTest);
                                    if (varConflict.Count == 0) //&& (y< tmpO))
                                    {
                                        Scheduler(starti);//indks);
                                        int rt = Funksioni_ObjFinal();//Funksioni_Obj1Ok(); //Obj_Funksioni();
                                        if (rt < tmpO)// dltF)
                                        {
                                            tmpO = rt;
                                            KaNderrim = true;
                                            Buffer.BlockCopy(rendAct, 0, rActTemp, 0, rendAct.Length * sizeof(int));
                                            //Buffer.BlockCopy(actFunditProjStarti, 0, actFunditProjStartiTemp, 0, actFunditProjStarti.Length * sizeof(int));
                                            KaN = true;
                                        }
                                    }
                                }
                                l2n++;
                            }

                            l++;
                        }
                        rendAct[act1, 0] = modZ02;
                        rendAct[act1, 1] = durModZ02;
                        rendAct[act1, 2] = startZ02;

                        rendAct[act2, 0] = modZ03;
                        rendAct[act2, 1] = durModZ03;
                        rendAct[act2, 2] = startZ03;
                    }
                }
            if (KaNderrim)
            {
                rendAct = rActTemp;
                dtf = tmpO;
                return true;
            }
            else
            {
                rendAct = rAct;
                return false;
            }
        }


        internal bool MinConOMC(int starti, ref int dtf)//26 Janar 2017
        {
            ArrayList al = new ArrayList();
            bool KaNderrim = false;
            int tmpO = dtf;//
            int[,] rAct = new int[NrAct, 3];
            int[,] rActTemp = new int[NrAct, 3];         
            Buffer.BlockCopy(rendAct, 0, rAct, 0, rendAct.Length * sizeof(int));
            int l = 0;
            int varSetSize; //=  al.Count - 1;
            if (NrAct - starti >= 11) varSetSize = 11;
            else varSetSize = NrAct - starti;

            for (int yt = starti; yt < starti + varSetSize; yt++)
            {
                if (rendAct[vAct[yt], 1] > 0) al.Add(yt);
            }

            int indeksi;// = l;        
            bool KaN = true;//,
            while ((KaN) && (al.Count > 0))
            {
                KaN = false;
                int act1;//, 
                indeksi = rand.Next(0, al.Count);            
                indeksi = (int)(al[indeksi]);
                act1 = vAct[indeksi];// rendAct[indeksi, 0]; //
                al.Remove(indeksi);

                int modZ = rendAct[act1, 0];
                int durZ = rendAct[act1, 1];
                int startZ = rendAct[act1, 2];
                int nrModeve = problemiObj.precedenceRelationsPrSuc[act1][1];
                if (nrModeve > 1)
                {
                    l = 0;
                    int[,] vargAct = problemiObj.DicT[act1];
                    int prj = Rezultati.actThjeshtimi[act1, 0];// == pr1)
                    ArrayList acNeTest = new ArrayList();
                    if (!acNeTest.Contains(prj)) acNeTest.Add(prj);
                    while (l < nrModeve)//(l < Rezultati.AModLen1) && (problemiObj.aModRes[l, 0] == act1))
                    {
                        if (vargAct[l, 0] != modZ) //problemiObj.aModRes[l, 1] != modZ)
                        {                        
                            rendAct[act1, 0] = vargAct[l, 0];// modZ1;
                            rendAct[act1, 1] = vargAct[l, 1];//durModZ1;
                            varConflict.Clear();
                            NonRenLocalModCh(acNeTest); //KtheVarNeKonfliktNonRenLocal(acNeTest);

                            if (varConflict.Count == 0) //&& (y< tmpO))
                            {
                                Scheduler(starti);// 
                                int rt = Funksioni_ObjFinal();//Funksioni_Obj1O
                                if (rt < tmpO)// dltF)
                                {
                                    tmpO = rt;
                                    KaNderrim = true;
                                    Buffer.BlockCopy(rendAct, 0, rActTemp, 0, rendAct.Length * sizeof(int));
                                    KaN = true;
                                }                           
                            }                          
                        }
                        l++;
                    }               
                    rendAct[act1, 0] = modZ;
                    rendAct[act1, 1] = durZ;
                    rendAct[act1, 2] = startZ;                 
                }

            }
            if (KaNderrim)
            {
                rendAct = rActTemp;
                dtf = tmpO;
                return true;
            }
            else
            {
                rendAct = rAct;
                return false;
            }
        }


        internal void ComF(int prj)
        {
            int[] rAct = new int[NrAct];
            int j = 0, h = 0;
            int dimProj = problemiObj.projectInfoPr[prj, 1];
            int indeksiPasDim = dimProj;
            while ((j < dimProj) && (h < NrAct))// rAct.GetLength(0)))
            {
                if (Rezultati.actThjeshtimi[vAct[h], 0] == prj)
                {
                    rAct[j] = vAct[h];// rendAct[h, 0];              
                    j++;
                }
                else
                {
                    rAct[indeksiPasDim] = vAct[h];                 
                    indeksiPasDim++;
                }

                h++;
            }

            while (indeksiPasDim < NrAct)// rAct.GetLength(0))
            {
                rAct[indeksiPasDim] = vAct[h];           
                indeksiPasDim++;
                h++;
            }
            vAct = rAct;
            Scheduler(0);
        }

        internal void ComE(int prj)
        {
            int[] rAct = new int[NrAct];
            //Buffer.BlockCopy(rendAct, 0, rAct, 0, rendAct.Length * sizeof(int));
            int j = 0, h = 0, fill = -1;
            int dimProj = problemiObj.projectInfoPr[prj, 1];
            int indeksiPasDim = NrAct - dimProj;

            while ((indeksiPasDim < NrAct) && (h < NrAct)) //rAct.GetLength(0)))
            {
                if (Rezultati.actThjeshtimi[vAct[h], 0] != prj)
                {
                    rAct[j] = vAct[h];// rendAct[h, 0];               
                    j++;
                }
                else
                {
                    if (fill == -1) fill = h;
                    rAct[indeksiPasDim] = vAct[h];//                 
                    indeksiPasDim++;
                }

                h++;
            }

            while (h < NrAct) //rAct.GetLength(0))
            {
                rAct[j] = vAct[h];//r
                j++;
                h++;
            }
            vAct = rAct;
            Scheduler(fill);
        }


        internal void PCom(int pr1)//, int pr2)
        {            
            int funpr1, fillpr1 = -1;
            int[] rAct = new int[NrAct];//, 4];
            Buffer.BlockCopy(vAct, 0, rAct, 0, vAct.Length * sizeof(int));
            int j = NrAct - 1;//, pozfund = -1;
            bool UGjet2 = false;
            int k = problemiObj.projectInfoPr[pr1, 1];
            int nr = rand.Next(4, 11), numero = 0;
            nr = k * (nr * 5) / 100;
            funpr1 = ActIndk(Rezultati.fillFundProjekteve[pr1, 1]);           
            j = funpr1;
            while (!UGjet2)// || (!UGjet2))
            {
                if (Rezultati.actThjeshtimi[vAct[j], 0] == pr1)
                {
                    numero++;
                    if (numero == nr) { fillpr1 = j; UGjet2 = true; }
                }
                j--;
            }        
            j = fillpr1 + 1;
            int indrAct = fillpr1 + 1;
            int indrPasAct = nr + fillpr1;
            while (j <= funpr1)
            {
                if (Rezultati.actThjeshtimi[rAct[j], 0] == pr1)
                {                   
                    vAct[indrAct] = rAct[j];
                    indrAct++;
                }
                else
                {                    
                    vAct[indrPasAct] = rAct[j];
                    indrPasAct++;
                }
                j++;
            }
            Scheduler(fillpr1);
        }


        internal void PerturbimiModeve(int nrPert)//ref int dltF)//int ht, ref int dltF)
        {
            int z = rand.Next(0, NrAct);
            for (int i = 0; i < nrPert; i++)
            {
                while (!ManipuloModetBool(z))
                {
                    while (Rezultati.IsT(vAct[z]))//.IsTD(vAct[z], Rezultati.modesTabuListLen, Rezultati.dcTN1))//
                    {
                        z = rand.Next(0, NrAct);
                    }
                }
            }
        }

        internal bool ManipuloModetBool(int z)//, ref int dltF, ref int y)//, int delF)
        {
            int act = z;
            z = vAct[act];// rendAct[act, 0];//
            if (problemiObj.precedenceRelationsPrSuc[z][1] > 1)
            {
                ArrayList acNeTest = new ArrayList();
                ArrayList aModet = new ArrayList();
                int prj1 = Rezultati.actThjeshtimi[z, 0];//act,0];////
                acNeTest.Add(prj1);
                //int startiPrj1 = Rezultati.fillFundProjekteve[prj1, 0];
                //Buffer.BlockCopy(rendAct, 0, rAct, 0, rendAct.Length * sizeof(int));        

                int[,] vargAct = problemiObj.DicT[z];
                int nrModeve = problemiObj.precedenceRelationsPrSuc[z][1];
                int l = 0;
                int modV = rendAct[z, 0];
                for (int i = 0; i < nrModeve; i++)
                {
                    if (modV != vargAct[i, 0]) aModet.Add(vargAct[i, 0]);
                }

                int modZ = rand.Next(0, aModet.Count);//1, nrModeve+1);//
                modZ = (int)aModet[modZ];

                rendAct[z, 0] = modZ;
                while (l < nrModeve)//((l < Rezultati.AModLen1) && (problemiObj.aModRes[l, 0] == z))//
                {
                    if (vargAct[l, 0] == modZ) //problemiObj.aModRes[l, 1] != modZ)
                    {
                        varConflict.Clear();
                        //KtheVarNeKonfliktNonRenLocal(acNeTest);//rendAct);//
                        NonRenLocalModCh(acNeTest);
                        if (varConflict.Count > 0) { rendAct[z, 0] = modV; return false; }// rendAct[z, 2] = vargAct[l, 1]; SNonRenRes(); Scheduler(0); return true; }//  SNonRenRes();}// 
                        else
                        {
                            rendAct[z, 1] = vargAct[l, 1];// meqe modet jane ne rangun 1,..,3, atehere duration eshte ne indeksin modZ-1 //problemiObj.aModRes[l, 2];                          
                            Scheduler(act);
                            return true;
                        }
                    }

                    l++;
                }
            }
            return false;
        }
             
        internal void _MinConFMC(int y)
        {
            int z;//, tmpObj = int.MaxValue;
            int ac = rand.Next(0, NrAct);//
            int dlf = int.MaxValue;
            //if (!Rezultati.MMLib)
            //{
                CloneSeq(ac);//                                 
                int tmpObj = Funksioni_ObjFinal();
                if (tmpObj < deltaF)
                {
                    deltaF = tmpObj;
                    Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                    Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                }
            //}
            int fi = 0, fu = NrAct, dm = NrAct / 4;
            switch (y)
            {
                case 1: fi = 0; fu = dm; break;
                case 2: fi = dm - 1; fu = 2 * dm; break;
                case 3: fi = 2 * dm - 1; fu = 3 * dm; break;
                case 4: fi = 3 * dm - 1; fu = 4 * dm; break;
            }
         
            DateTime dt = DateTime.Now;
            DateTime dt1 = dt.AddMilliseconds(1000);//
            while (DateTime.Now < dt1)//
            {
                z = rand.Next(fi, fu);//
                while (Rezultati.IsT(vAct[z]))  z = rand.Next(fi, fu);//0,           
                if (MinConFMC(z, ref dlf))// 
                {
                    if (dlf < deltaF)
                    {
                        deltaF = dlf; //
                        Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                        Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));
                      
                    }                 
                }
            }
        }


        internal bool MinConFMC(int starti, ref int dtf)//, int iter1)ArrayList adl
        {
            //ArrayList al = new ArrayList();
            ArrayList actPerseritura = new ArrayList();
            int tmpO = dtf;
            int[,] rAct = new int[NrAct, 3];
            int[,] rActTemp = new int[NrAct, 3];
            bool KaNderrim = false;
            if (NrAct - starti >= 4) //tw = 3;
            {
                Buffer.BlockCopy(rendAct, 0, rAct, 0, rendAct.Length * sizeof(int));
                int indeksi1;// = l, 
                int indeksi2;// = l;
                int indeksi3;
                int indeksi4;
                int act0, act1, act2, act3;//, nrperpjekje = 0;
                indeksi1 = starti;//(int)adl[0]; //
                act0 = vAct[indeksi1];// rendAct[indeksi1, 0]; //(int)(al[act1]);
                indeksi2 = starti + 1; //(int)adl[1]; //starti + 1;//ioo;// 
                act1 = vAct[indeksi2];// rendAct[indeksi2, 0];
                indeksi3 = starti + 2; //(int)adl[2]; //starti + 2;//ioi;// starti + 2;
                act2 = vAct[indeksi3];//rendAct[indeksi3, 0];
                indeksi4 = starti + 1; //(int)adl[3]; //starti + 3;//ioi;// starti + 2;
                act3 = vAct[indeksi4];//rendAct[indeksi4, 0];
                starti = Math.Min(Math.Min(indeksi1, indeksi2), Math.Min(indeksi3,indeksi4));
                int prj1 = Rezultati.actThjeshtimi[act0, 0];// == pr1)
                int prj2 = Rezultati.actThjeshtimi[act1, 0];
                int prj3 = Rezultati.actThjeshtimi[act2, 0];
                int prj4 = Rezultati.actThjeshtimi[act3, 0];
                ArrayList acNeTest = new ArrayList();
                acNeTest.Add(prj1);// Rezultati.actThjeshtimi[rendAct[indeksi1, 0], 0]);
                if (!acNeTest.Contains(prj2)) acNeTest.Add(prj2);
                if (!acNeTest.Contains(prj3)) acNeTest.Add(prj3);
                if (!acNeTest.Contains(prj4)) acNeTest.Add(prj4);              
                int l = 0;
                int l1n = 0;// KtheIndeksBS(act1);//l2;
                int l2n = 0;// KtheIndeksBS(act2);//l2;
                int l3n = 0;// KtheIndeksBS(act3);
                int nrModeve0 = problemiObj.precedenceRelationsPrSuc[act0][1];
                int nrModeve1 = problemiObj.precedenceRelationsPrSuc[act1][1];
                int nrModeve2 = problemiObj.precedenceRelationsPrSuc[act2][1];
                int nrModeve3 = problemiObj.precedenceRelationsPrSuc[act3][1];
                int[,] vargAct0 = problemiObj.DicT[act0];
                int[,] vargAct1 = problemiObj.DicT[act1];
                int[,] vargAct2 = problemiObj.DicT[act2];
                int[,] vargAct3 = problemiObj.DicT[act3];
                while (l < nrModeve0)//((l < Rezultati.AModLen1) && (problemiObj.aModRes[l, 0] == act0))
                {
                    rendAct[vAct[indeksi1], 0] = vargAct0[l, 0];//modZ1;
                    rendAct[vAct[indeksi1], 1] = vargAct0[l, 1];//durModZ1;
                    l1n = 0;// 
                    while (l1n < nrModeve1)//((l1n < Rezultati.AModLen1) && (problemiObj.aModRes[l1n, 0] == act1))
                    {
                        rendAct[vAct[indeksi2], 0] = vargAct1[l1n, 0];//modZ2;
                        rendAct[vAct[indeksi2], 1] = vargAct1[l1n, 1];//durModZ2;
                        l2n = 0;// 
                        while (l2n < nrModeve2)//((l2n < Rezultati.AModLen1) && (problemiObj.aModRes[l2n, 0] == act2))
                        {
                            rendAct[vAct[indeksi3], 0] = vargAct2[l2n, 0];//modZ3;
                            rendAct[vAct[indeksi3], 1] = vargAct2[l2n, 1];//durModZ3;
                            l3n = 0;// 
                            while (l3n < nrModeve3)//((l3n < Rezultati.AModLen1) && (problemiObj.aModRes[l3n, 0] == act3))
                            {
                                rendAct[vAct[indeksi4], 0] = vargAct3[l3n, 0];//modZ4;
                                rendAct[vAct[indeksi4], 1] = vargAct3[l3n, 1];//durModZ4;
                                varConflict.Clear();
                                NonRenLocalModCh(acNeTest); // KtheVarNeKonfliktNonRenLocal(acNeTest);
                                if (varConflict.Count == 0) //&& (y< tmpO))
                                {
                                    Scheduler(starti);// indkl);
                                    int rt = Funksioni_ObjFinal();// Funksioni_Obj1Ok(); //
                                    if (rt < tmpO)// dltF)
                                    {
                                        tmpO = rt;
                                        KaNderrim = true;
                                        Buffer.BlockCopy(rendAct, 0, rActTemp, 0, rendAct.Length * sizeof(int));
                                    }

                                }                            
                                l3n++;
                            }
                            l2n++;
                        }
                        l1n++;
                    }
                    l++;
                }
                if (KaNderrim)
                {
                    rendAct = rActTemp;
                    dtf = tmpO;

                    return true;
                }
                else
                {
                    rendAct = rAct;
                    return false;
                }
            }
            else return false;
        }
               
        internal void Scheduler(int poz)
        {
            for (int i = poz; i < NrAct; i++)
            {
                int dritarjaM = -1;
                int nrParaArdh = problemiObj.precedenceRelationsPrPre[vAct[i]].Length;////rendAct[i, 0]].Length;
                for (int j = 3; j < nrParaArdh; j++)
                {
                    int pr = problemiObj.precedenceRelationsPrPre[vAct[i]][j];//rendAct[i, 0]][j];                    
                    if (rendAct[pr, 2] + rendAct[pr, 1] > dritarjaM)
                    {
                        dritarjaM = rendAct[pr, 2] + rendAct[pr, 1];
                    }                   
                }
                if (dritarjaM == -1) dritarjaM = problemiObj.projectInfoPr[Rezultati.actThjeshtimi[vAct[i], 0], 2];//rendAct[i, 0], 0], 2];
                rendAct[vAct[i], 2] = dritarjaM;
                int k = dritarjaM, tempF = 0, hapi;
                bool UVendos = false, Doli = false;
                while (!UVendos)
                {
                    if (rendAct[vAct[i], 1] == 0)
                    {
                        rendAct[vAct[i], 2] = k;
                        UVendos = true;
                    }
                    else
                    {
                        bool UGjetFill = false;
                        for (int l = k; l < k + rendAct[vAct[i], 1]; l++)
                        {
                            hapi = 10000;
                            ArrayList lActMomentT = new ArrayList();
                            for (int m = tempF; m <= i; m++)
                            {
                                if ((rendAct[vAct[m], 2] <= l) && ((rendAct[vAct[m], 2] + rendAct[vAct[m], 1]) > l))
                                {
                                    if (!UGjetFill) { tempF = m; UGjetFill = true; }
                                    if (!lActMomentT.Contains(m))
                                    {
                                        if ((rendAct[vAct[m], 2] + rendAct[vAct[m], 1]) < hapi) hapi = rendAct[vAct[m], 2] + rendAct[vAct[m], 1];
                                        lActMomentT.Add(m);
                                    }
                                }
                                else if (rendAct[vAct[m], 2] > l) { if (!UGjetFill) { tempF = m; UGjetFill = true; } }
                            }                           
                            if (lActMomentT.Count > 0)
                            {
                                varConflict.Clear();
                                KtheVarNeKonfliktRenLocl(lActMomentT);
                                if (varConflict.Count > 0)
                                {
                                    k = hapi - 1;
                                    Doli = true;
                                    break;
                                }
                            }
                        }

                        k++;
                        if (!Doli)
                        {
                            UVendos = true;
                            rendAct[vAct[i], 2] = k - 1;
                        }
                        else
                        {
                            rendAct[vAct[i], 2] = k;
                            Doli = false;
                        }

                    }
                }

            }
        }
                      
        internal int KtheIndeksBSPr(int pr)
        {
            int dimProj0 = Rezultati.AModLen1 - 1;
            int dimProj1 = Rezultati.AModLen2 - 1;
            int filli = 0;//problemiObj.actFillFunProjaMod[proj, 0];
            int fundi = Rezultati.AModLen1 - 1;// 
            int mesi = -1;
            while (filli < fundi - 1)
            {
                mesi = (filli + fundi) / 2;
                if (pr < problemiObj.aModRes[mesi, dimProj1])
                    fundi = mesi;
                else if (pr > problemiObj.aModRes[mesi, dimProj1])
                    filli = mesi;
                else
                    break;
            }

            if (pr != problemiObj.aModRes[mesi, dimProj1])
            {
                if (pr == problemiObj.aModRes[filli, dimProj1]) mesi = filli;
                else mesi = fundi;
            }
            if (mesi > 0)
            {
                while (problemiObj.aModRes[mesi, dimProj1] == problemiObj.aModRes[mesi - 1, dimProj1])
                {
                    mesi--;
                    if (mesi <= 0) break;
                }
            }
            return mesi;
        }

        private int ActIndk(int acT)
        {
            if (acT < NrAct / 2)
            {
                for (int tr = 0; tr < NrAct; tr++)
                {
                    if (vAct[tr] == acT)
                    {
                        return tr;
                    }
                }
            }
            else
            {
                for (int tr = NrAct - 1; tr >= 0; tr--)
                {
                    if (vAct[tr] == acT)
                    {
                        return tr;
                    }
                }
            }
            return -1;//
        }

        public bool MinConSJL(int actPoz, ref int dltF)
        {
            int[,] rAct = new int[NrAct, 3];
            int[] rA = new int[NrAct];
            int act = vAct[actPoz];
            int pozFill = actPoz - 1, tmp = dltF;// int.MaxValue; //+ 1; 
            if (pozFill > 0)
            {
                Buffer.BlockCopy(rendAct, 0, rAct, 0, rendAct.Length * sizeof(int));
                Buffer.BlockCopy(vAct, 0, rA, 0, vAct.Length * sizeof(int));
                while ((!EshteParaardhesNeSeq(act, vAct[pozFill])) && (pozFill >= 0))//rendAct[pozFill, 0])) && (pozFill >= 0))
                {
                    pozFill--;
                    if (pozFill < 0) { break; } //pozFill = 0;
                }
                pozFill++;
                bool KaNderrim = false;
                int[,] rAcTemp = new int[NrAct, 3];
                int[] rAtmp = new int[NrAct];
                if (pozFill < actPoz - 1)
                {
                    int k = pozFill;
                    while (k < actPoz)
                    {
                        int f3 = vAct[actPoz];// rendAct[actPoz, 0];
                        vAct[actPoz] = vAct[k]; //rendAct[actPoz, 0] = rendAct[k, 0];
                        vAct[k] = f3;
                            int pFill = k + 1;
                            for (int m = pFill; m < actPoz; m++)
                            {
                                if (EshtePasardhesNeSeq(vAct[actPoz], vAct[m]))
                                {
                                    int f4 = vAct[m];// rendAct[actPoz, 0];
                                    vAct[m] = vAct[actPoz]; //rendAct[actPoz, 0] = rendAct[k, 0];
                                    vAct[actPoz] = f4;
                                }
                            }
                        Scheduler(k);
                        int rt = Funksioni_ObjFinal(); //Obj_Funksioni();
                        if (rt < tmp)// dltF)//tmpO)//
                        {
                            tmp = rt;
                            KaNderrim = true;
                            Buffer.BlockCopy(rendAct, 0, rAcTemp, 0, rendAct.Length * sizeof(int));
                            Buffer.BlockCopy(vAct, 0, rAtmp, 0, vAct.Length * sizeof(int));
                        }
                        Buffer.BlockCopy(rAct, 0, rendAct, 0, rAct.Length * sizeof(int));
                        Buffer.BlockCopy(rA, 0, vAct, 0, rA.Length * sizeof(int));
                        k++;
                    }

                    if (KaNderrim)
                    {
                        rendAct = rAcTemp;
                        vAct = rAtmp;
                        dltF = tmp;
                        return true;
                    }
                    else
                    {
                        rendAct = rAct;
                        vAct = rA;
                        return false;
                    }
                }
            }
            return false;
        }


        public bool MinConSJR(int actPoz, ref int dltF)
        {
            int[,] rAct = new int[NrAct, 3];
            int[] rA = new int[NrAct];
            int act = vAct[actPoz];
            int pozFill = actPoz + 1, tmp = dltF;// int.MaxValue; //+ 1; 
            if (pozFill < NrAct)
            {
                Buffer.BlockCopy(rendAct, 0, rAct, 0, rendAct.Length * sizeof(int));
                Buffer.BlockCopy(vAct, 0, rA, 0, vAct.Length * sizeof(int));
                while ((!EshtePasardhesNeSeq(act, vAct[pozFill])) && (pozFill < NrAct))//rendAct[pozFill, 0])) && (pozFill >= 0))
                {
                    pozFill++;
                    if (pozFill >= NrAct) { break; }//pozFill = NrAct - 1; 
                }
                pozFill--;
                bool KaNderrim = false;
                int[,] rAcTemp = new int[NrAct, 3];
                int[] rAtmp = new int[NrAct];
                if (pozFill > actPoz + 1)
                {
                    int k = pozFill;
                    while (k > actPoz)
                    {
                        int f3 = vAct[actPoz];// rendAct[actPoz, 0];
                        vAct[actPoz] = vAct[k]; //rendAct[actPoz, 0] = rendAct[k, 0];
                        vAct[k] = f3;////rendAct[k, 0] = f3;
                        ///////////
                        int pFill = k - 1;
                        for (int m = pFill; m > actPoz; m--)
                        {
                            if (EshteParaardhesNeSeq(vAct[actPoz], vAct[m]))
                            {
                                int f4 = vAct[m];// rendAct[actPoz, 0];
                                vAct[m] = vAct[actPoz]; //rendAct[actPoz, 0] = rendAct[k, 0];
                                vAct[actPoz] = f4;
                            }
                        }
                        Scheduler(actPoz);
                        int rt = Funksioni_ObjFinal(); //Obj_Funksioni();
                        if (rt < tmp)// dltF)//tmpO)//
                        {
                            tmp = rt;
                            KaNderrim = true;
                            Buffer.BlockCopy(rendAct, 0, rAcTemp, 0, rendAct.Length * sizeof(int));
                            Buffer.BlockCopy(vAct, 0, rAtmp, 0, vAct.Length * sizeof(int));
                        }
                        Buffer.BlockCopy(rAct, 0, rendAct, 0, rAct.Length * sizeof(int));
                        Buffer.BlockCopy(rA, 0, vAct, 0, rA.Length * sizeof(int));
                        k--;
                    }
                    if (KaNderrim)
                    {
                        rendAct = rAcTemp;
                        vAct = rAtmp;
                        dltF = tmp;
                        //if (KaGab(actPoz, pozFill)) Console.WriteLine("D");
                        return true;
                    }
                    else
                    {
                        rendAct = rAct;
                        vAct = rA;
                        return false;
                    }
                }
            }
            return false;
        }
        ////////////////////
        internal void _MinConSJR()//, 
        {
            int dlf = int.MaxValue, z;
            bool KaNdr = true;
            DateTime dt = DateTime.Now;
            DateTime dt1 = dt.AddMilliseconds(1000);
            DateTime dt2 = dt.AddMilliseconds(3000);
            while(((KaNdr) || (DateTime.Now < dt1)) && (DateTime.Now < dt2))
            {
                KaNdr = false;
                z = rand.Next(0, NrAct);//fi, fu);//
                int nrPasardhes = problemiObj.precedenceRelationsPrSuc[vAct[z]].Length - 3;
                while ((nrPasardhes == 0) || (Rezultati.IsTD(vAct[z], Rezultati.seqTabuListLen, Rezultati.dcTN2)))//
                {
                    z = rand.Next(0, NrAct);//fi, fu);//0, NrAct);
                    nrPasardhes = problemiObj.precedenceRelationsPrSuc[vAct[z]].Length - 3;
                }
                if (MinConSJR(z, ref dlf))
                {                  
                        if (dlf < deltaF)
                        {
                            deltaF = dlf;
                            Buffer.BlockCopy(vAct, 0, varguActMM, 0, vAct.Length * sizeof(int));
                            Buffer.BlockCopy(rendAct, 0, zgjidhjaMeeMire, 0, rendAct.Length * sizeof(int));//
                            KaNdr = true;
                        }                   
                }

            }          
        }

        internal void Perturbate(int pertSizeThreshold)
        {
            int dimen = NrAct / 10;
            if (pertSizeThreshold > dimen) { pertSizeThreshold = dimen; }
            PerturbimiModeve(pertSizeThreshold);
        }
      
    }
}